-- By Ashnal
-- Simple script that preserves deployed/thrown items reference to the player that threw them
-- Fixes the circumstance where a player deploys an item, but then dies while the item still exists, and the reference to the owning player is lost
-- Mostly relevant for mods like Hitfeed or HPmod that track source players
-- May have a non-negligible performance impact if you have tons of these trap items laying around on the ground

if not au_preservetargetrefscript then rawset(_G, "au_preservetargetrefscript", true) else return end

local mobjtypelist = {
	MT_ORBINAUT,
	MT_BANANA,
	MT_SSMINE_SHIELD, -- the enum in hardcode is swapped with SSMINE in dehacked.c, so to properly hook SSMINE we need to specify SSMINE_SHIELD
	MT_JAWZ,
	MT_JAWZ_DUD,
	MT_SINK,
	MT_EGGMANITEM,
	MT_BALLHOG,
	MT_SPB
}

for _,v in pairs(mobjtypelist) do
	addHook("MobjThinker", function(mo)
		if not mo.playersource and mo.target and mo.target.player then mo.playersource = mo.target.player end
		if not mo.target and mo.playersource and mo.playersource.valid and mo.playersource.mo then mo.target = mo.playersource.mo end
	end, v)
end