rawset(_G, "MasterEmerald", {})

if not MasterEmerald.Init then
	--Init------|
	----And-----|
	------Sync--|

	local function em_init(p)
		p.masteremerald = {
			sparkle = 0,
			super = 0, -- Super flag
			supercolor = p.emcolor_backup or -1,
			--prev tics
			LFitem = 0,
			LFamount = 0
		}
	end
	addHook("PlayerSpawn", em_init)
	
	MasterEmerald.Init = true
else
	return
end

MasterEmerald.CheckCombi = function(p)
	if not (hcombi and hcombi.combi_on) then return false end
	if p and p.valid then
		if p.has_partner then return true end
		return false
	end
	return true
end
MasterEmerald.Prefix = {Error = "\133SUPER FORM ERROR:\128 ", Warning = "\130SUPER FORM WARNING:\128 "}
MasterEmerald.SuperColorList = {[0] = {SKINCOLOR_SUPER1,SKINCOLOR_SUPER2,SKINCOLOR_SUPER3,SKINCOLOR_SUPER4,SKINCOLOR_SUPER5,SKINCOLOR_SUPER4,SKINCOLOR_SUPER3,SKINCOLOR_SUPER2},
								[1] = {SKINCOLOR_TSUPER1,SKINCOLOR_TSUPER2,SKINCOLOR_TSUPER3,SKINCOLOR_TSUPER4,SKINCOLOR_TSUPER5,SKINCOLOR_TSUPER4,SKINCOLOR_TSUPER3,SKINCOLOR_TSUPER2},
								[2] = {SKINCOLOR_KSUPER1,SKINCOLOR_KSUPER2,SKINCOLOR_KSUPER3,SKINCOLOR_KSUPER4,SKINCOLOR_KSUPER5,SKINCOLOR_KSUPER4,SKINCOLOR_KSUPER3,SKINCOLOR_KSUPER2},
								[3] = {SKINCOLOR_PSUPER1,SKINCOLOR_PSUPER2,SKINCOLOR_PSUPER3,SKINCOLOR_PSUPER4,SKINCOLOR_PSUPER5,SKINCOLOR_PSUPER4,SKINCOLOR_PSUPER3,SKINCOLOR_PSUPER2},
								[4] = {SKINCOLOR_BSUPER1,SKINCOLOR_BSUPER2,SKINCOLOR_BSUPER3,SKINCOLOR_BSUPER4,SKINCOLOR_BSUPER5,SKINCOLOR_BSUPER4,SKINCOLOR_BSUPER3,SKINCOLOR_BSUPER2},
								[5] = {SKINCOLOR_ASUPER1,SKINCOLOR_ASUPER2,SKINCOLOR_ASUPER3,SKINCOLOR_ASUPER4,SKINCOLOR_ASUPER5,SKINCOLOR_ASUPER4,SKINCOLOR_ASUPER3,SKINCOLOR_ASUPER2},
								[6] = {SKINCOLOR_GSUPER1,SKINCOLOR_GSUPER2,SKINCOLOR_GSUPER3,SKINCOLOR_GSUPER4,SKINCOLOR_GSUPER5,SKINCOLOR_GSUPER4,SKINCOLOR_GSUPER3,SKINCOLOR_GSUPER2},
								[7] = {SKINCOLOR_WSUPER1,SKINCOLOR_WSUPER2,SKINCOLOR_WSUPER3,SKINCOLOR_WSUPER4,SKINCOLOR_WSUPER5,SKINCOLOR_WSUPER4,SKINCOLOR_WSUPER3,SKINCOLOR_WSUPER2},
								[8] = {SKINCOLOR_CSUPER1,SKINCOLOR_CSUPER2,SKINCOLOR_CSUPER3,SKINCOLOR_CSUPER4,SKINCOLOR_CSUPER5,SKINCOLOR_CSUPER4,SKINCOLOR_CSUPER3,SKINCOLOR_CSUPER2},
								[9] = {SKINCOLOR_SUPER1,SKINCOLOR_SUPER2,SKINCOLOR_SUPER3,SKINCOLOR_SUPER4,SKINCOLOR_WSUPER5,
								       //SKINCOLOR_TSUPER1,SKINCOLOR_TSUPER2,SKINCOLOR_TSUPER3,SKINCOLOR_TSUPER4,SKINCOLOR_WSUPER5,
									   SKINCOLOR_KSUPER1,SKINCOLOR_KSUPER2,SKINCOLOR_KSUPER3,SKINCOLOR_KSUPER4,SKINCOLOR_WSUPER5,
									   SKINCOLOR_PSUPER1,SKINCOLOR_PSUPER2,SKINCOLOR_PSUPER3,SKINCOLOR_PSUPER4,SKINCOLOR_WSUPER5,
									   //SKINCOLOR_BSUPER1,SKINCOLOR_BSUPER2,SKINCOLOR_BSUPER3,SKINCOLOR_BSUPER4,SKINCOLOR_WSUPER5,
									   SKINCOLOR_ASUPER1,SKINCOLOR_ASUPER2,SKINCOLOR_ASUPER3,SKINCOLOR_ASUPER4,SKINCOLOR_WSUPER5,
									   SKINCOLOR_GSUPER1,SKINCOLOR_GSUPER2,SKINCOLOR_GSUPER3,SKINCOLOR_GSUPER4,SKINCOLOR_WSUPER5}
	}
MasterEmerald.SuperColorName = {default = -1,
								yellow = 0,
								orange = 1,
								red = 2,
								pink = 3,
								blue = 4,
								aqua = 5,
								green = 6,
								white = 7,
								cream = 8,
								hyper = 9
}

COM_AddCommand("em_supercolor", function(player, arg)
	
	arg = tostring(arg):lower()
	local color = nil
	
	if arg then
		color = MasterEmerald.SuperColorName[arg]
		if color == nil then
			if tonumber(arg) != nil and tonumber(arg) >= -1 and tonumber(arg) <= 9 then
				color = tonumber(arg)
			end
		end
	end
	
	if color != nil and color >= -1 and color <= 9 then
		CONS_Printf(player, "\131* Super Color has been changed")
		S_StartSound(nil, sfx_radio, player)
		player.masteremerald.supercolor = color
		player.emcolor_backup = color
	else
		CONS_Printf(player,"\131* Super Color Options: ")
		CONS_Printf(player,"\130Yellow  \135Orange  \133Red")
		CONS_Printf(player,"\141Pink    \132Blue    \136Aqua")
		CONS_Printf(player,"\131Green   \134White   \143Cream")
		CONS_Printf(player,"\140Hyper           \128Default")
		
	end

end)

local function NewAsset(name)
	if rawget(_G, name) == nil then
		freeslot(name)
	end
	
	return _G[name]
end

MasterEmerald.Transformations = {}
MasterEmerald.AddTransformation = function(...)
	local packedargs = {...}
	
	for k,v in ipairs(packedargs)
		----------------------
		-- Valid Skin Check --
		----------------------
		if type(v.skin) != "string" then
			print(MasterEmerald.Prefix.Error.."Skin (\130"..tostring(skin).."\128) Must be a number")
			return
		end
		----------------------
		-- Valid Form Check --
		----------------------
		if type(v.form) == "table" then
			--print("Form table found.")
			if v.form.sprite then
				if type(v.form.sprite) == "string" then
					--print(v.form.sprite.." found, assembling...")
					local spr = NewAsset("SPR_"..(v.form.sprite:upper()))
					local s = NewAsset("S_EM_"..(v.form.sprite:upper()).."_SIGN")
					states[s] = 
					{sprite = spr,
					frame = S,tics = -1,
					var1 = 0,var2 = 24}
				
					packedargs[k].form.sprite = {super_sprite = spr, super_sign = s}
					--print("Assembled "..packedargs[k].form.sprite.super_sprite.." and "..packedargs[k].form.sprite.super_sign)
				else
					packedargs[k].form.sprite = nil
				end
			else
				packedargs[k].form.sprite = nil
			end

			if v.form.beam then
				if type(v.form.beam) == "number" 
				and (v.form.beam >= 1 and v.form.beam < MAXSKINCOLORS) then
					packedargs[k].form.beam = v.form.beam
					--print("Beam color is "..packedargs[k].form.beam)
				else
					print(MasterEmerald.Prefix.Error.."Invalid beam color")
					packedargs[k].form.beam = SKINCOLOR_GOLD
				end
			else
				packedargs[k].form.beam = SKINCOLOR_GOLD
			end

			if v.form.color then
				if type(v.form.color) == "string" then
					if MasterEmerald.SuperColorName[string.lower(v.form.color)] >= -1 and MasterEmerald.SuperColorName[string.lower(v.form.color)] <= 9 then
						packedargs[k].form.color = MasterEmerald.SuperColorName[string.lower(v.form.color)]
						--print("Form color is "..packedargs[k].form.color)
					else
						print(MasterEmerald.Prefix.Error.."Invalid Super Color (\130"..tostring(skin).."\128) (invalid string)")
						packedargs[k].form.color = 0
					end
				elseif type(v.form.color) == "number" then
					if v.form.color < -1 or v.form.color > 10 then
						print(MasterEmerald.Prefix.Error.."Invalid Super Color (\130"..tostring(skin).."\128)")
						packedargs[k].form.color = 0
					end
				end
			else
				packedargs[k].form.color = 0
			end
		
			if v.form.music then
				if type(v.form.music) == "string" then
					if not S_MusicExists(v.form.music) then
						print(MasterEmerald.Prefix.Error.."Super Music (\130"..v.form.music.."\128) not found")
					end
					--print("Music theme is "..packedargs[k].form.music)
				elseif type(v.form.music) == "table" then
					local temp_table = v.form.music
					for key,song in ipairs(temp_table) do
						if type(song) != "string" and not S_MusicExists(song) then
							print(MasterEmerald.Prefix.Error.."Super Music (\130"..song.."\128) not found")
							table.remove(temp_table, key)
						end
					end
					packedargs[k].form.music = temp_table
				else
					print(MasterEmerald.Prefix.Error.."Invalid Super Music (\130"..tostring(skin).."\128)")
					packedargs[k].form.music = "emsupr"
				end
			else
				packedargs[k].form.music = "emsupr"
			end
		else
			packedargs[k].form = {sprite = 0, color = 0, music = "emsupr", beam = SKINCOLOR_GOLD}
		end
		-------------------------
		-- Valid Emerald Check --
		-------------------------
		if type(v.emeralds) == "table" then
			local em = v.emeralds
			if em.sprite then
				if type(em.sprite) == "table" then
					for b,p in ipairs(em.sprite)
						if type(p) == "table" then
							if type(p[1]) == "string" then
								packedargs[k].emeralds.sprite[b][1] = NewAsset("SPR_"..(p[1]:upper()))
							elseif type(p[1]) != "number" then
								packedargs[k].emeralds.sprite[b][1] = SPR_OREM
							end
							if type(p[2]) == "number" then
								packedargs[k].emeralds.sprite[b][2] = tonumber(p[2])
							else -- Complete fallback
								packedargs[k].emeralds.sprite[b] = {SPR_OREM, 6}
							end
						else
							packedargs[k].emeralds.sprite[b] = {SPR_OREM, 6}
						end
					end
				else
					print(MasterEmerald.Prefix.Error.."Emerald Sprites Must Be a Table (\130"..tostring(skin).."\128)")
					packedargs[k].emeralds.sprite = {{SPR_OREM, 6}}
				end
			else
				packedargs[k].emeralds.sprite = {{SPR_OREM, 6}}
			end
		
			if em.count then
				packedargs[k].emeralds.count = tonumber(em.count) or 7
				--print("Emerald Count is "..packedargs[k].emeralds.count)
			else
				packedargs[k].emeralds.count = 7
			end
		
			if em.colors then
				if type(em.colors) == "table" then
					local temp_table = em.colors
					for key,color in ipairs(temp_table) do
						if type(color) != "number" and not (color > 0 and color <= 100) then
							print(MasterEmerald.Prefix.Error.."Invalid Emerald Color in Table(\130"..tostring(skin).."\128)")
						end
						--print("Emerald color "..color.." found.")
					end
				else
					print(MasterEmerald.Prefix.Error.."Emerald Colors Must Be a Table (\130"..tostring(skin).."\128)")
					packedargs[k].emeralds.colors = {SKINCOLOR_GREEN,SKINCOLOR_RED,SKINCOLOR_CYAN,SKINCOLOR_WHITE,
						SKINCOLOR_PURPLE,SKINCOLOR_BLUE,SKINCOLOR_YELLOW}
				end
			else
				packedargs[k].emeralds.colors = {SKINCOLOR_GREEN,SKINCOLOR_RED,SKINCOLOR_CYAN,SKINCOLOR_WHITE,
					SKINCOLOR_PURPLE,SKINCOLOR_BLUE,SKINCOLOR_YELLOW}
			end
		
			if em.scale then
				if type(em.scale) == "table" then
					for b,p in ipairs(em.scale)
						packedargs[k].emeralds.scale[b] = tonumber(p) or FRACUNIT
						--print("Scale "..packedargs[k].emeralds.scale[b].." found.")
					end
				else
					print(MasterEmerald.Prefix.Error.."Emerald Scale Must Be a Table (\130"..tostring(skin).."\128)")
					packedargs[k].emeralds.scale = {FRACUNIT}
				end
			else
				packedargs[k].emeralds.scale = {FRACUNIT}
			end
		else
			packedargs[k].emeralds = {sprite = {{SPR_OREM, 6}}, 
			count = 7, 
			scale = {FRACUNIT},
			colors = {SKINCOLOR_GREEN,SKINCOLOR_RED,SKINCOLOR_CYAN,SKINCOLOR_WHITE,
					SKINCOLOR_PURPLE,SKINCOLOR_BLUE,SKINCOLOR_YELLOW}
			}
		end
		
		/*
		if type(packedargs[k].form) == "table" then
			print("Super Form table successfully assembled.")
		end
		
		if type(packedargs[k].emeralds) == "table" then
			print("Emerald table successfully assembled.")
		end
		*/

		MasterEmerald.Transformations[packedargs[k].skin] = {form = packedargs[k].form, emeralds = packedargs[k].emeralds}
		print("Transformation for "..packedargs[k].skin.." successfully registered!")
	end
end

addHook("NetVars", function(net)
	MasterEmerald.Transformations = net($)
end)